import java.io.*;
import org.apache.tools.ant.*;

public class HTMLLogger implements BuildLogger
{
  private PrintStream out;
  private PrintStream err;
  private int msgLevel = Project.MSG_WARN;

  public void setEmacsMode(boolean emacsMode)
  {
    // wird nicht bentigt
  }

  public void setErrorPrintStream(java.io.PrintStream errstr)
  {
    err = new PrintStream(errstr, true);
  }

  // Level fr Log-Ausgabe setzen
  // welche Ausgaben pro Level gemacht werden, wird manuell festgelegt
  // int MSG_ERR     0
  // int MSG_WARN    1
  // int MSG_INFO    2
  // int MSG_VERBOSE 3
  // int MSG_DEBUG   4
  public void setMessageOutputLevel(int level)
  {
    msgLevel = level;
  }

  public void setOutputPrintStream(java.io.PrintStream outputstr)
  {
    // true - autom. leeren (autoflush)
    out = new PrintStream(outputstr, true);
  }

  public void messageLogged(BuildEvent event)
  {
    switch(event.getPriority())
    {
      case Project.MSG_ERR     : out.println("Error"); break;
      case Project.MSG_WARN    : out.println("Warning"); break;
//      case Project.MSG_INFO    : out.println("Information"); break;
//      case Project.MSG_VERBOSE : out.println("Verbose"); break;
//      case Project.MSG_DEBUG   : out.println("Debug-Mode"); break;
    }

    if ((event.getPriority() != Project.MSG_DEBUG) && (event.getPriority() != Project.MSG_INFO))
    {
      if (event.getMessage() != null)
      {
        out.println("<br><i><b>messageLogged</b></i><br>");
        out.println(event.getMessage() + "<br>");
      }
    }
  }

  public void buildFinished(BuildEvent event)
  {
    out.println("<br><i><b>buildFinished</b></i><br>");
    out.println("<br><body></html>");
  } 

  public void buildStarted(BuildEvent event)
  {
    out.println("<html><head><title>ProjektName: " + event.getProject().getName() +
                "</title></head><body><h1>ProjektName: "  + event.getMessage() +
                "</h1>");
    out.println("<br><i><b>buildStarted</b></i><br>");
  }

  public void targetFinished(BuildEvent event)
  {
    System.out.println("<br><i><b>targetFinished</b></i><br>");
  }

  public void targetStarted(BuildEvent event)
  {
    System.out.println("<br><i><b>targetStarted</b></i><br>");
  }

  public void taskFinished(BuildEvent event)
  {
    System.out.println("<br><i><b>taskFinished</b></i><br>");
  }

  public void taskStarted(BuildEvent event)
  {
    System.out.println("<br><i><b>taskStarted</b></i><br>");
  }
}
