package com.herdt.javxml.kap06;

import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import org.apache.xerces.parsers.*;

public class DOM2
{
  static Document doc;

  public DOM2()
  {
    DOMParser dom = new DOMParser();
    try
    {
      // Whitespaces unterdrcken
      dom.setFeature("http://apache.org/xml/features/dom/include-ignorable-whitespace", false);
      dom.parse("com\\herdt\\javxml\\kap06\\Dichter.xml");
      doc = dom.getDocument();
      System.out.println("Strukturbaum der Datei Dichter.xml vollstaendig aufgebaut");
    }
    catch(SAXException se)
    {
      System.out.println("Fehler beim Parsen: " + se.getMessage());
    }
    catch(IOException e)
    {
      System.out.println("E/A-Fehler: " + e.getMessage());
    }
  }

  public static void main(String[] args)
  {
    DOM2 dom2 = new DOM2();
    dom2.anzeigen(doc.getDocumentElement(), 1);
  }

  public void anzeigen(Node node, int stufe)
  {
    for(int i = 1; i < stufe; i++)
       System.out.print("  ");

    System.out.print(node.getNodeName() + " ");

    if(node.getNodeValue() != null)
      System.out.print("= " + node.getNodeValue() + " ");

    if(node.hasAttributes())
    {
      NamedNodeMap attribs = node.getAttributes();
      for(int i = 0; i < attribs.getLength(); i++)
        System.out.print(attribs.item(i).getNodeName() + " = " + attribs.item(i).getNodeValue() + " ");
    }

    System.out.println();

    if(node.hasChildNodes())
    {
      stufe++;
      NodeList childs = node.getChildNodes();
      for(int i = 0; i < childs.getLength(); i++)
        this.anzeigen(childs.item(i), stufe);
    }
    else
      stufe--;
  }
}
