package com.herdt.javxml.kap06;

import java.io.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.DOMImplementationImpl;
import org.apache.xml.serialize.*;

public class Uebung1
{

  public static void main(String[] args)
  {
    Uebung1 uebung1 = new Uebung1();
    uebung1.erstelleDOM();
  }

  void erstelleDOM()
  {
    DOMImplementationImpl domImpl = new DOMImplementationImpl();
    Document doc = domImpl.createDocument(null, "Benutzer", null);
    //----DocumentType dt = domImpl.createDocumentType("BENUTZER", null, null);
    try
    {
      // Wurzelknoten
      Element nodeWurzel = doc.getDocumentElement();

      Comment c = doc.createComment("Benutzer meines Webshops");
      nodeWurzel.appendChild(c);

      // Person hinzufgen
      System.out.println("\nEingabe der Benutzer\n");
      boolean weiter = true;
      while(weiter)
      {
        // PERSON erstellen
        Element nodePerson = doc.createElement("Person");
        nodeWurzel.appendChild(nodePerson);

        // NAME erstellen
        Element node = doc.createElement("Name");
        nodePerson.appendChild(node);
        System.out.print("Name: ");
        String eingabe = readString();
        Text text = doc.createTextNode(eingabe);
        node.appendChild(text);

        // ANSCHRIFT erstellen
        node = doc.createElement("Anschrift");
        nodePerson.appendChild(node);
        System.out.print("Anschrift: ");
        eingabe = readString();
        text = doc.createTextNode(eingabe);
        node.appendChild(text);

        // TELEFON erstellen
        node = doc.createElement("Telefon");
        nodePerson.appendChild(node);
        System.out.print("Telefon: ");
        eingabe = readString();
        text = doc.createTextNode(eingabe);
        node.appendChild(text);
        System.out.print("Mobiltelefon (j/n): ");
        eingabe = readString();
        node.setAttribute("Mobil", eingabe);

        // Attribute fr PERSON erstellen
        System.out.print("Geburtsdatum: ");
        eingabe = readString();
        nodePerson.setAttribute("Gebdatum", eingabe);
        System.out.print("Geschlecht (m/w): ");
        eingabe = readString();
        nodePerson.setAttribute("Geschelcht", eingabe);

        System.out.print("weitere Personen erfassen (j/n): ");
        eingabe = readString();
        if(!((eingabe.equals("j")) || (eingabe.equals("J"))))
          weiter = false;
      }
    }
    catch(DOMException domex)
    {
      System.out.println("DOMException: " + domex.getMessage());
    }
    // Ausgabe des XML-Dokuments
    try
    {
      FileWriter fw = new FileWriter("com\\herdt\\javxml\\kap06\\Uebung1.xml", false);
      OutputFormat format = new OutputFormat(doc);
      format.setIndenting(true);
      format.setIndent(2);
      format.setLineSeparator("\r\n");
      format.setEncoding("ISO-8859-1");
      XMLSerializer serializer = new XMLSerializer(fw, format);
      serializer.serialize(doc);
      System.out.println("XML-Dokument erfolgreich erstellt.");
    }
    catch(IOException ioex)
    {
      System.out.println("IOException: " + ioex.getMessage());
    }
  }

  String readString()
    {
      BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
      String name = "";
      try
      {
        name = br.readLine();
      }
      catch(IOException ioex)
      {
        System.out.println("IOException: " + ioex.getMessage());
      }
      return(name);
  }
}
