package com.herdt.javxml.kap06;

import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import org.apache.xerces.parsers.*;
import org.apache.xml.serialize.*;

public class Uebung2
{
  static Document doc;

  public Uebung2()
  {
    // Parsen des XML-Dokuments
    DOMParser dom = new DOMParser();
    try
    {
      dom.setFeature("http://apache.org/xml/features/dom/include-ignorable-whitespace", false);
      dom.parse("com\\herdt\\javxml\\kap06\\Uebung1.xml");
      System.out.println("Strukturbaum der Datei Uebung1.xml vollstaendig aufgebaut");
    }
    catch(SAXException se)
    {
      System.out.println("Fehler beim Parsen: " + se.getMessage());
    }
    catch(IOException e)
    {
      System.out.println("E/A-Fehler: " + e.getMessage());
    }
    doc = dom.getDocument();
  }

  public static void main(String[] args)
  {
    Uebung2 domUebung2 = new Uebung2();
    domUebung2.anzeigen();
    domUebung2.strukturAendern();
    domUebung2.loescheBenutzer();
    domUebung2.anzeigen();
    domUebung2.speichern();
  }

  static void anzeigen()
  {
    System.out.println("\nStrukturbaum-Anzeige");
    System.out.println("====================\n");
    OutputFormat format = new OutputFormat(doc);
    format.setIndenting(true);
    format.setIndent(2);
    format.setLineSeparator("\r\n");
    try
    {
      XMLSerializer serializer = new XMLSerializer(System.out, format);
      serializer.serialize(doc);
    }
     catch(IOException ioex)
     {
       System.out.println("IOException: " + ioex.getMessage());
    }
    System.out.println();
  }

  static void strukturAendern()
  {
    System.out.println("\nStruktur aendern");
    System.out.println("================\n");
    NodeList nl = doc.getElementsByTagName("Person");
    DOM3 dom3 = new DOM3(1);
    for(int i = 0; i < nl.getLength(); i++)
    {
      Node nodePerson = nl.item(i);
      NodeList nlPerson = nodePerson.getChildNodes();
      Node nodeName = null;
      Node nodeAdresse = null;
      for(int j = 0; j < nlPerson.getLength(); j++)
      {
        if(nlPerson.item(j).getNodeName().equals("Name"))
          nodeName = nlPerson.item(j);
        if(nlPerson.item(j).getNodeName().equals("Anschrift"))
          nodeAdresse = nlPerson.item(j);
      }
      System.out.print("E-Mail-Adresse von " + nodeName.getFirstChild().getNodeValue() + ": ");
      String email = readString();
      Element nodeEmail = doc.createElement("EMail");
      Text text = doc.createTextNode(email);
      nodeEmail.appendChild(text);
      nodePerson.replaceChild(nodeEmail, nodeAdresse);
      System.out.println("geaenderte Personendaten: ");
      dom3.anzeigen(nodePerson, 1);
    }
  }

  static String readString()
  {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    String name = "";
    try
    {
      name = br.readLine();
    }
    catch(IOException ioex)
    {
      System.out.println("IOException: " + ioex.getMessage());
    }
    return(name);
  }

  void loescheBenutzer()
  {
    System.out.println("\nLoeschen eines Benutzers");
    System.out.println("========================\n");
    DOM3 dom3 = new DOM3(1);
    String weiter = "j";
    while(weiter.equals("j") || weiter.equals("J"))
    {
      System.out.print("Name des Benutzers: ");
      String name = readString();
      Node nodeName = knotenSuchen(name);
      if(nodeName != null)
      {
        Node nodePerson = nodeName.getParentNode();
        dom3.anzeigen(nodePerson, 1);
        System.out.print("wirklich loeschen (j/n): ");
        String s = readString();
        if(s.equals("j") || s.equals("J"))
        {
          nodePerson.getParentNode().removeChild(nodePerson);
          System.out.println("Person " + name + " geloescht");
        }
      }
      System.out.print("weiter (j/n): ");
      weiter = readString();
    }
  }

  Node knotenSuchen(String name)
  {
    NodeList nl = doc.getElementsByTagName("Name");
    for(int i = 0; i < nl.getLength(); i++)
      if(nl.item(i).getFirstChild().getNodeValue().equals(name))
         return(nl.item(i));
    System.out.println("Person nicht gefunden\n");
    return(null);
  }

  void speichern()
  {
    try
    {
      FileWriter fw = new FileWriter("com\\herdt\\javxml\\kap06\\Uebung2.xml", false);
      OutputFormat format = new OutputFormat(doc);
      format.setIndenting(true);
      format.setIndent(2);
      format.setLineSeparator("\r\n");
      format.setEncoding("ISO-8859-1");
      XMLSerializer serializer = new XMLSerializer(fw, format);
      serializer.serialize(doc);
      System.out.println("XML-Dokument Uebung2.xml erfolgreich erstellt.");
    }
    catch(IOException ioex)
    {
      System.out.println("IOException: " + ioex.getMessage());
     }
  }
}
